`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 2020/05/01 15:50:17
// Design Name: 
// Module Name: counter_month
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////


module counter_month(
    input clk,
    input rst_n,
    input next_month,
    input leap,
    output reg [3:0]value0,
    output reg [3:0]value1,
    output reg next_year,
    output reg [3:0]limit1,
    output reg [3:0]limit0
    );
    reg [3:0]month1_tmp, month0_tmp;

always@*
    if (value1 == 4'd1 && value0 == 4'd2 && next_month)
        begin
            month1_tmp = 0;
            month0_tmp = 1;
            next_year = 1;
        end
    else if (value0 == 4'd9 && next_month)
        begin
            month1_tmp = value1 + 1;
            month0_tmp = 0;
            next_year = 0;
        end
    else if (next_month)
        begin
            month1_tmp = value1;
            month0_tmp = value0 + 1;
            next_year = 0;
        end
    else
        begin
            month1_tmp = value1;
            month0_tmp = value0;
            next_year = 0;
        end
        
always@(posedge clk or negedge rst_n)
    if(~rst_n)
        begin
            value0 <= 1;
            value1 <= 0;
        end
    else
        begin
            value0 <= month0_tmp;
            value1 <= month1_tmp;
        end

always@*
    case ({value1,value0})
        {4'd0,4'd1}: {limit1,limit0} = {4'd3,4'd1}; // Jan
        {4'd0,4'd2}: {limit1,limit0} = {4'd2,4'd8 + leap}; // Feb
        {4'd0,4'd3}: {limit1,limit0} = {4'd3,4'd1}; // March
        {4'd0,4'd4}: {limit1,limit0} = {4'd3,4'd0}; // Apr
        {4'd0,4'd5}: {limit1,limit0} = {4'd3,4'd1}; // May
        {4'd0,4'd6}: {limit1,limit0} = {4'd3,4'd0}; // June
        {4'd0,4'd7}: {limit1,limit0} = {4'd3,4'd1}; // July
        {4'd0,4'd8}: {limit1,limit0} = {4'd3,4'd1}; // Aug
        {4'd0,4'd9}: {limit1,limit0} = {4'd3,4'd0}; // Sept
        {4'd1,4'd0}: {limit1,limit0} = {4'd3,4'd1}; // Oct
        {4'd1,4'd1}: {limit1,limit0} = {4'd3,4'd0}; // Nov
        {4'd1,4'd2}: {limit1,limit0} = {4'd3,4'd1}; // Dec
        default: {limit1,limit0} = {4'd3,4'd1};
    endcase

endmodule